Index: trunk/src/emx/src/lib/socket/socket.imp
===================================================================
--- trunk/src/emx/src/lib/socket/socket.imp	(revision 186)
+++ trunk/src/emx/src/lib/socket/socket.imp	(revision 186)
@@ -0,0 +1,257 @@
+;$Id$
+
+;
+; so32dll.imp (created by emximp)
+;
+; -------- so32dll.lib --------
+tcpip40_accept                  so32dll    1 ?
+tcpip40_bind                    so32dll    2 ?
+tcpip40_connect                 so32dll    3 ?
+tcpip40_gethostid               so32dll    4 ?
+tcpip40_getpeername             so32dll    5 ?
+tcpip40_getsockname             so32dll    6 ?
+tcpip40_getsockopt              so32dll    7 ?
+tcpip40_so_ioctl                so32dll    8 ?
+tcpip40_listen                  so32dll    9 ?
+tcpip40_recv                    so32dll   10 ?
+tcpip40_recvfrom                so32dll   11 ?
+tcpip40_os2_select              so32dll   12 ?
+tcpip40_send                    so32dll   13 ?
+tcpip40_sendto                  so32dll   14 ?
+tcpip40_setsockopt              so32dll   15 ?
+tcpip40_socket                  so32dll   16 ?
+tcpip40_soclose                 so32dll   17 ?
+tcpip40_so_cancel               so32dll   18 ?
+tcpip40_soabort                 so32dll   19 ?
+tcpip40_sock_errno              so32dll   20 ?
+tcpip40_recvmsg                 so32dll   21 ?
+tcpip40_sendmsg                 so32dll   22 ?
+tcpip40_readv                   so32dll   23 ?
+tcpip40_writev                  so32dll   24 ?
+tcpip40_shutdown                so32dll   25 ?
+tcpip40_sock_init               so32dll   26 ?
+tcpip40_addsockettolist         so32dll   27 ?
+tcpip40_removesocketfromlist    so32dll   28 ?
+tcpip40_psock_errno             so32dll   30 ?
+tcpip40_getinetversion          so32dll   31 ?
+tcpip40_bsdselect               so32dll   32 ?
+tcpip40_set_errno               so32dll   35 ?
+tcpip40_getsocketfromlist       so32dll   39 ?
+
+
+;
+; tcp32dll.imp (created by emximp)
+;
+; -------- tcp32dll.lib --------
+tcpip40_settimeofday            tcp32dll   1 ?
+tcpip40_gettimeofday            tcp32dll   2 ?
+tcpip40_lswap                   tcp32dll   3 ?
+tcpip40_bswap                   tcp32dll   4 ?
+tcpip40_inet_addr               tcp32dll   5 ?
+tcpip40_inet_lnaof              tcp32dll   6 ?
+tcpip40_inet_netof              tcp32dll   7 ?
+tcpip40_inet_makeaddr           tcp32dll   8 ?
+tcpip40_inet_network            tcp32dll   9 ?
+tcpip40_inet_ntoa               tcp32dll  10 ?
+tcpip40_gethostbyname           tcp32dll  11 ?
+tcpip40_gethostbyaddr           tcp32dll  12 ?
+tcpip40_getnetbyname            tcp32dll  13 ?
+tcpip40_getnetbyaddr            tcp32dll  14 ?
+tcpip40_setnetent               tcp32dll  15 ?
+tcpip40_endnetent               tcp32dll  16 ?
+tcpip40_getnetent               tcp32dll  17 ?
+tcpip40_setprotoent             tcp32dll  18 ?
+tcpip40_endprotoent             tcp32dll  19 ?
+tcpip40_getprotoent             tcp32dll  20 ?
+tcpip40_getprotobyname          tcp32dll  21 ?
+tcpip40_getprotobynumber        tcp32dll  22 ?
+tcpip40_getservbyport           tcp32dll  23 ?
+tcpip40_getservbyname           tcp32dll  24 ?
+tcpip40_setservent              tcp32dll  25 ?
+tcpip40_endservent              tcp32dll  26 ?
+tcpip40_getservent              tcp32dll  27 ?
+tcpip40_sethostent              tcp32dll  28 ?
+tcpip40_endhostent              tcp32dll  29 ?
+tcpip40_gethostent              tcp32dll  30 ?
+tcpip40_dn_expand               tcp32dll  31 ?
+tcpip40_dn_comp                 tcp32dll  32 ?
+tcpip40_dn_skipname             tcp32dll  33 ?
+tcpip40_dn_find                 tcp32dll  34 ?
+tcpip40__getshort               tcp32dll  35 ?
+tcpip40__getlong                tcp32dll  36 ?
+tcpip40_putshort                tcp32dll  37 ?
+tcpip40_putlong                 tcp32dll  38 ?
+tcpip40_res_init                tcp32dll  39 ?
+tcpip40_res_mkquery             tcp32dll  40 ?
+tcpip40_res_send                tcp32dll  41 ?
+tcpip40_h_errno                 tcp32dll  42 ?
+tcpip40__res                    tcp32dll  43 ?
+tcpip40_gethostname             tcp32dll  44 ?
+tcpip40_rexec                   tcp32dll  45 ?
+tcpip40_gethostbyname_r         tcp32dll  48 ?
+tcpip40_gethostbyaddr_r         tcp32dll  49 ?
+tcpip40_getservbyname_r         tcp32dll  50 ?
+tcpip40_tcp_h_errno             tcp32dll  51 ?
+tcpip40_res_search              tcp32dll  52 ?
+tcpip40_res_query               tcp32dll  53 ?
+tcpip40_res_querydomain         tcp32dll  54 ?
+tcpip40_Raccept                 tcp32dll  56 ?
+tcpip40_Rbind                   tcp32dll  57 ?
+tcpip40_Rconnect                tcp32dll  58 ?
+tcpip40_Rgetsockname            tcp32dll  59 ?
+tcpip40_Rlisten                 tcp32dll  60 ?
+tcpip40_Rgethostbyname          tcp32dll  61 ?
+
+
+
+;
+; tcpip32.imp (created by emximp)
+;
+; -------- tcpip32.lib --------
+accept                  tcpip32    1 ?
+bind                    tcpip32    2 ?
+connect                 tcpip32    3 ?
+gethostid               tcpip32    4 ?
+getpeername             tcpip32    5 ?
+getsockname             tcpip32    6 ?
+getsockopt              tcpip32    7 ?
+so_ioctl                tcpip32    8 ?
+listen                  tcpip32    9 ?
+recv                    tcpip32   10 ?
+recvfrom                tcpip32   11 ?
+os2_select              tcpip32   12 ?
+send                    tcpip32   13 ?
+sendto                  tcpip32   14 ?
+setsockopt              tcpip32   15 ?
+socket                  tcpip32   16 ?
+soclose                 tcpip32   17 ?
+so_cancel               tcpip32   18 ?
+soabort                 tcpip32   19 ?
+sock_errno              tcpip32   20 ?
+recvmsg                 tcpip32   21 ?
+sendmsg                 tcpip32   22 ?
+readv                   tcpip32   23 ?
+writev                  tcpip32   24 ?
+shutdown                tcpip32   25 ?
+sock_init               tcpip32   26 ?
+addsockettolist         tcpip32   27 ?
+removesocketfromlist    tcpip32   28 ?
+cleanupsockets          tcpip32   29 ?
+psock_errno             tcpip32   30 ?
+getinetversion          tcpip32   31 ?
+bsdselect               tcpip32   32 ?
+set_errno               tcpip32   35 ?
+winsockcleanupsockets   tcpip32   38 ?
+gettimeofday            tcpip32  102 ?
+inet_addr               tcpip32  105 ?
+inet_lnaof              tcpip32  106 ?
+inet_netof              tcpip32  107 ?
+inet_makeaddr           tcpip32  108 ?
+inet_network            tcpip32  109 ?
+inet_ntoa               tcpip32  110 ?
+gethostbyname           tcpip32  111 ?
+gethostbyaddr           tcpip32  112 ?
+getnetbyname            tcpip32  113 ?
+getnetbyaddr            tcpip32  114 ?
+setnetent               tcpip32  115 ?
+endnetent               tcpip32  116 ?
+getnetent               tcpip32  117 ?
+setprotoent             tcpip32  118 ?
+endprotoent             tcpip32  119 ?
+getprotoent             tcpip32  120 ?
+getprotobyname          tcpip32  121 ?
+getprotobynumber        tcpip32  122 ?
+getservbyport           tcpip32  123 ?
+getservbyname           tcpip32  124 ?
+setservent              tcpip32  125 ?
+endservent              tcpip32  126 ?
+getservent              tcpip32  127 ?
+sethostent              tcpip32  128 ?
+endhostent              tcpip32  129 ?
+gethostent              tcpip32  130 ?
+__dn_expand             tcpip32  131 ?
+__dn_comp               tcpip32  132 ?
+__dn_skipname           tcpip32  133 ?
+dn_find                 tcpip32  134 ?
+_getshort               tcpip32  135 ?
+_getlong                tcpip32  136 ?
+__putshort              tcpip32  137 ?
+__putlong               tcpip32  138 ?
+__res_init              tcpip32  139 ?
+__res_mkquery           tcpip32  140 ?
+__res_send              tcpip32  141 ?
+_ress                   tcpip32  143 ?
+gethostname             tcpip32  144 ?
+rexec                   tcpip32  145 ?
+tcp_h_errno1            tcpip32  151 ?
+__res_search            tcpip32  152 ?
+__res_query             tcpip32  153 ?
+__res_querydomain       tcpip32  154 ?
+Raccept                 tcpip32  156 ?
+Rbind                   tcpip32  157 ?
+Rconnect                tcpip32  158 ?
+Rgetsockname            tcpip32  159 ?
+Rlisten                 tcpip32  160 ?
+Rgethostbyname          tcpip32  161 ?
+os2_ioctl               tcpip32  200 ?
+__TCPFDIsSet            tcpip32  201 ?
+conv_sockaddr_parms     tcpip32  202 ?
+htonl                   tcpip32  203 ?
+ntohl                   tcpip32  204 ?
+htons                   tcpip32  205 ?
+ntohs                   tcpip32  206 ?
+sysctl                  tcpip32  207 ?
+herror                  tcpip32  208 ?
+hstrerror               tcpip32  209 ?
+__p_class_syms          tcpip32  211 ?
+__p_type_syms           tcpip32  212 ?
+__res_hnok              tcpip32  213 ?
+__res_ownok             tcpip32  214 ?
+__res_mailok            tcpip32  215 ?
+__res_dnok              tcpip32  216 ?
+__sym_ston              tcpip32  217 ?
+__sym_ntos              tcpip32  218 ?
+__sym_ntop              tcpip32  219 ?
+__b64_ntop              tcpip32  220 ?
+__B64_PTOn              tcpip32  221 ?
+__b64_pton              tcpip32  221 ?
+__loc_aton              tcpip32  222 ?
+__loc_ntoa              tcpip32  223 ?
+__fp_resstat            tcpip32  224 ?
+__fp_query              tcpip32  225 ?
+__fp_nquery             tcpip32  226 ?
+__hostalias             tcpip32  227 ?
+__p_class               tcpip32  228 ?
+__p_time                tcpip32  229 ?
+__p_type                tcpip32  230 ?
+__p_query               tcpip32  231 ?
+__p_cdnname             tcpip32  232 ?
+__p_cdname              tcpip32  233 ?
+__p_fqnname             tcpip32  234 ?
+__p_fqname              tcpip32  235 ?
+__p_rr                  tcpip32  236 ?
+__p_option              tcpip32  237 ?
+__p_secstodate          tcpip32  238 ?
+__dn_count_labels       tcpip32  239 ?
+__res_randomid          tcpip32  240 ?
+__res_isourserver       tcpip32  241 ?
+__res_nameinquery       tcpip32  242 ?
+__res_queriesmatch      tcpip32  243 ?
+__res_close             tcpip32  244 ?
+gethostbyname2          tcpip32  245 ?
+inet_aton               tcpip32  246 ?
+inet_neta               tcpip32  247 ?
+inet_net_ntop           tcpip32  248 ?
+inet_net_pton           tcpip32  249 ?
+inet_pton               tcpip32  250 ?
+inet_ntop               tcpip32  251 ?
+inet_nsap_addr          tcpip32  252 ?
+inet_nsap_ntoa          tcpip32  253 ?
+socketpair              tcpip32  254 ?
+sock_strerror           tcpip32  255 ?
+accept_and_recv         tcpip32  256 ?
+send_file               tcpip32  257 ?
+kernchkacc              tcpip32  300 ?
+convert16to32bitaddr    tcpip32  301 ?
+socketmain              tcpip32  302 ?
+
Index: trunk/src/emx/src/lib/socket/socket.smak
===================================================================
--- trunk/src/emx/src/lib/socket/socket.smak	(revision 186)
+++ trunk/src/emx/src/lib/socket/socket.smak	(revision 186)
@@ -0,0 +1,22 @@
+# This is the top-level submakefile for building EMX C runtime library
+
+.MODULE	:= libsocket
+.MDESC	:= The socket library
+
+.TARGET	:= libsocket_p.a
+.TKIND	:= aout prof
+.TSRC	:= src/lib/socket/herror.c
+.TSRC   += $(wildcard src/lib/socket/386/*.s)
+.TDEP	:=
+.IMPS   := src/lib/socket/socket.imp
+.INSDIR	= lib/
+.TKEEP	:= 1
+include mkimplib.smak
+
+.TARGET	:= libsocket.a
+.TKIND	:= aout
+include mkimplib.smak
+
+
+# Forget temporary variables
+include comend.smak
Index: trunk/src/emx/src/libsocket/socket.imp
===================================================================
--- trunk/src/emx/src/libsocket/socket.imp	(revision 186)
+++ trunk/src/emx/src/libsocket/socket.imp	(revision 186)
@@ -0,0 +1,257 @@
+;$Id$
+
+;
+; so32dll.imp (created by emximp)
+;
+; -------- so32dll.lib --------
+tcpip40_accept                  so32dll    1 ?
+tcpip40_bind                    so32dll    2 ?
+tcpip40_connect                 so32dll    3 ?
+tcpip40_gethostid               so32dll    4 ?
+tcpip40_getpeername             so32dll    5 ?
+tcpip40_getsockname             so32dll    6 ?
+tcpip40_getsockopt              so32dll    7 ?
+tcpip40_so_ioctl                so32dll    8 ?
+tcpip40_listen                  so32dll    9 ?
+tcpip40_recv                    so32dll   10 ?
+tcpip40_recvfrom                so32dll   11 ?
+tcpip40_os2_select              so32dll   12 ?
+tcpip40_send                    so32dll   13 ?
+tcpip40_sendto                  so32dll   14 ?
+tcpip40_setsockopt              so32dll   15 ?
+tcpip40_socket                  so32dll   16 ?
+tcpip40_soclose                 so32dll   17 ?
+tcpip40_so_cancel               so32dll   18 ?
+tcpip40_soabort                 so32dll   19 ?
+tcpip40_sock_errno              so32dll   20 ?
+tcpip40_recvmsg                 so32dll   21 ?
+tcpip40_sendmsg                 so32dll   22 ?
+tcpip40_readv                   so32dll   23 ?
+tcpip40_writev                  so32dll   24 ?
+tcpip40_shutdown                so32dll   25 ?
+tcpip40_sock_init               so32dll   26 ?
+tcpip40_addsockettolist         so32dll   27 ?
+tcpip40_removesocketfromlist    so32dll   28 ?
+tcpip40_psock_errno             so32dll   30 ?
+tcpip40_getinetversion          so32dll   31 ?
+tcpip40_bsdselect               so32dll   32 ?
+tcpip40_set_errno               so32dll   35 ?
+tcpip40_getsocketfromlist       so32dll   39 ?
+
+
+;
+; tcp32dll.imp (created by emximp)
+;
+; -------- tcp32dll.lib --------
+tcpip40_settimeofday            tcp32dll   1 ?
+tcpip40_gettimeofday            tcp32dll   2 ?
+tcpip40_lswap                   tcp32dll   3 ?
+tcpip40_bswap                   tcp32dll   4 ?
+tcpip40_inet_addr               tcp32dll   5 ?
+tcpip40_inet_lnaof              tcp32dll   6 ?
+tcpip40_inet_netof              tcp32dll   7 ?
+tcpip40_inet_makeaddr           tcp32dll   8 ?
+tcpip40_inet_network            tcp32dll   9 ?
+tcpip40_inet_ntoa               tcp32dll  10 ?
+tcpip40_gethostbyname           tcp32dll  11 ?
+tcpip40_gethostbyaddr           tcp32dll  12 ?
+tcpip40_getnetbyname            tcp32dll  13 ?
+tcpip40_getnetbyaddr            tcp32dll  14 ?
+tcpip40_setnetent               tcp32dll  15 ?
+tcpip40_endnetent               tcp32dll  16 ?
+tcpip40_getnetent               tcp32dll  17 ?
+tcpip40_setprotoent             tcp32dll  18 ?
+tcpip40_endprotoent             tcp32dll  19 ?
+tcpip40_getprotoent             tcp32dll  20 ?
+tcpip40_getprotobyname          tcp32dll  21 ?
+tcpip40_getprotobynumber        tcp32dll  22 ?
+tcpip40_getservbyport           tcp32dll  23 ?
+tcpip40_getservbyname           tcp32dll  24 ?
+tcpip40_setservent              tcp32dll  25 ?
+tcpip40_endservent              tcp32dll  26 ?
+tcpip40_getservent              tcp32dll  27 ?
+tcpip40_sethostent              tcp32dll  28 ?
+tcpip40_endhostent              tcp32dll  29 ?
+tcpip40_gethostent              tcp32dll  30 ?
+tcpip40_dn_expand               tcp32dll  31 ?
+tcpip40_dn_comp                 tcp32dll  32 ?
+tcpip40_dn_skipname             tcp32dll  33 ?
+tcpip40_dn_find                 tcp32dll  34 ?
+tcpip40__getshort               tcp32dll  35 ?
+tcpip40__getlong                tcp32dll  36 ?
+tcpip40_putshort                tcp32dll  37 ?
+tcpip40_putlong                 tcp32dll  38 ?
+tcpip40_res_init                tcp32dll  39 ?
+tcpip40_res_mkquery             tcp32dll  40 ?
+tcpip40_res_send                tcp32dll  41 ?
+tcpip40_h_errno                 tcp32dll  42 ?
+tcpip40__res                    tcp32dll  43 ?
+tcpip40_gethostname             tcp32dll  44 ?
+tcpip40_rexec                   tcp32dll  45 ?
+tcpip40_gethostbyname_r         tcp32dll  48 ?
+tcpip40_gethostbyaddr_r         tcp32dll  49 ?
+tcpip40_getservbyname_r         tcp32dll  50 ?
+tcpip40_tcp_h_errno             tcp32dll  51 ?
+tcpip40_res_search              tcp32dll  52 ?
+tcpip40_res_query               tcp32dll  53 ?
+tcpip40_res_querydomain         tcp32dll  54 ?
+tcpip40_Raccept                 tcp32dll  56 ?
+tcpip40_Rbind                   tcp32dll  57 ?
+tcpip40_Rconnect                tcp32dll  58 ?
+tcpip40_Rgetsockname            tcp32dll  59 ?
+tcpip40_Rlisten                 tcp32dll  60 ?
+tcpip40_Rgethostbyname          tcp32dll  61 ?
+
+
+
+;
+; tcpip32.imp (created by emximp)
+;
+; -------- tcpip32.lib --------
+accept                  tcpip32    1 ?
+bind                    tcpip32    2 ?
+connect                 tcpip32    3 ?
+gethostid               tcpip32    4 ?
+getpeername             tcpip32    5 ?
+getsockname             tcpip32    6 ?
+getsockopt              tcpip32    7 ?
+so_ioctl                tcpip32    8 ?
+listen                  tcpip32    9 ?
+recv                    tcpip32   10 ?
+recvfrom                tcpip32   11 ?
+os2_select              tcpip32   12 ?
+send                    tcpip32   13 ?
+sendto                  tcpip32   14 ?
+setsockopt              tcpip32   15 ?
+socket                  tcpip32   16 ?
+soclose                 tcpip32   17 ?
+so_cancel               tcpip32   18 ?
+soabort                 tcpip32   19 ?
+sock_errno              tcpip32   20 ?
+recvmsg                 tcpip32   21 ?
+sendmsg                 tcpip32   22 ?
+readv                   tcpip32   23 ?
+writev                  tcpip32   24 ?
+shutdown                tcpip32   25 ?
+sock_init               tcpip32   26 ?
+addsockettolist         tcpip32   27 ?
+removesocketfromlist    tcpip32   28 ?
+cleanupsockets          tcpip32   29 ?
+psock_errno             tcpip32   30 ?
+getinetversion          tcpip32   31 ?
+bsdselect               tcpip32   32 ?
+set_errno               tcpip32   35 ?
+winsockcleanupsockets   tcpip32   38 ?
+gettimeofday            tcpip32  102 ?
+inet_addr               tcpip32  105 ?
+inet_lnaof              tcpip32  106 ?
+inet_netof              tcpip32  107 ?
+inet_makeaddr           tcpip32  108 ?
+inet_network            tcpip32  109 ?
+inet_ntoa               tcpip32  110 ?
+gethostbyname           tcpip32  111 ?
+gethostbyaddr           tcpip32  112 ?
+getnetbyname            tcpip32  113 ?
+getnetbyaddr            tcpip32  114 ?
+setnetent               tcpip32  115 ?
+endnetent               tcpip32  116 ?
+getnetent               tcpip32  117 ?
+setprotoent             tcpip32  118 ?
+endprotoent             tcpip32  119 ?
+getprotoent             tcpip32  120 ?
+getprotobyname          tcpip32  121 ?
+getprotobynumber        tcpip32  122 ?
+getservbyport           tcpip32  123 ?
+getservbyname           tcpip32  124 ?
+setservent              tcpip32  125 ?
+endservent              tcpip32  126 ?
+getservent              tcpip32  127 ?
+sethostent              tcpip32  128 ?
+endhostent              tcpip32  129 ?
+gethostent              tcpip32  130 ?
+__dn_expand             tcpip32  131 ?
+__dn_comp               tcpip32  132 ?
+__dn_skipname           tcpip32  133 ?
+dn_find                 tcpip32  134 ?
+_getshort               tcpip32  135 ?
+_getlong                tcpip32  136 ?
+__putshort              tcpip32  137 ?
+__putlong               tcpip32  138 ?
+__res_init              tcpip32  139 ?
+__res_mkquery           tcpip32  140 ?
+__res_send              tcpip32  141 ?
+_ress                   tcpip32  143 ?
+gethostname             tcpip32  144 ?
+rexec                   tcpip32  145 ?
+tcp_h_errno1            tcpip32  151 ?
+__res_search            tcpip32  152 ?
+__res_query             tcpip32  153 ?
+__res_querydomain       tcpip32  154 ?
+Raccept                 tcpip32  156 ?
+Rbind                   tcpip32  157 ?
+Rconnect                tcpip32  158 ?
+Rgetsockname            tcpip32  159 ?
+Rlisten                 tcpip32  160 ?
+Rgethostbyname          tcpip32  161 ?
+os2_ioctl               tcpip32  200 ?
+__TCPFDIsSet            tcpip32  201 ?
+conv_sockaddr_parms     tcpip32  202 ?
+htonl                   tcpip32  203 ?
+ntohl                   tcpip32  204 ?
+htons                   tcpip32  205 ?
+ntohs                   tcpip32  206 ?
+sysctl                  tcpip32  207 ?
+herror                  tcpip32  208 ?
+hstrerror               tcpip32  209 ?
+__p_class_syms          tcpip32  211 ?
+__p_type_syms           tcpip32  212 ?
+__res_hnok              tcpip32  213 ?
+__res_ownok             tcpip32  214 ?
+__res_mailok            tcpip32  215 ?
+__res_dnok              tcpip32  216 ?
+__sym_ston              tcpip32  217 ?
+__sym_ntos              tcpip32  218 ?
+__sym_ntop              tcpip32  219 ?
+__b64_ntop              tcpip32  220 ?
+__B64_PTOn              tcpip32  221 ?
+__b64_pton              tcpip32  221 ?
+__loc_aton              tcpip32  222 ?
+__loc_ntoa              tcpip32  223 ?
+__fp_resstat            tcpip32  224 ?
+__fp_query              tcpip32  225 ?
+__fp_nquery             tcpip32  226 ?
+__hostalias             tcpip32  227 ?
+__p_class               tcpip32  228 ?
+__p_time                tcpip32  229 ?
+__p_type                tcpip32  230 ?
+__p_query               tcpip32  231 ?
+__p_cdnname             tcpip32  232 ?
+__p_cdname              tcpip32  233 ?
+__p_fqnname             tcpip32  234 ?
+__p_fqname              tcpip32  235 ?
+__p_rr                  tcpip32  236 ?
+__p_option              tcpip32  237 ?
+__p_secstodate          tcpip32  238 ?
+__dn_count_labels       tcpip32  239 ?
+__res_randomid          tcpip32  240 ?
+__res_isourserver       tcpip32  241 ?
+__res_nameinquery       tcpip32  242 ?
+__res_queriesmatch      tcpip32  243 ?
+__res_close             tcpip32  244 ?
+gethostbyname2          tcpip32  245 ?
+inet_aton               tcpip32  246 ?
+inet_neta               tcpip32  247 ?
+inet_net_ntop           tcpip32  248 ?
+inet_net_pton           tcpip32  249 ?
+inet_pton               tcpip32  250 ?
+inet_ntop               tcpip32  251 ?
+inet_nsap_addr          tcpip32  252 ?
+inet_nsap_ntoa          tcpip32  253 ?
+socketpair              tcpip32  254 ?
+sock_strerror           tcpip32  255 ?
+accept_and_recv         tcpip32  256 ?
+send_file               tcpip32  257 ?
+kernchkacc              tcpip32  300 ?
+convert16to32bitaddr    tcpip32  301 ?
+socketmain              tcpip32  302 ?
+
Index: trunk/src/emx/src/libsocket/socket.smak
===================================================================
--- trunk/src/emx/src/libsocket/socket.smak	(revision 186)
+++ trunk/src/emx/src/libsocket/socket.smak	(revision 186)
@@ -0,0 +1,22 @@
+# This is the top-level submakefile for building EMX C runtime library
+
+.MODULE	:= libsocket
+.MDESC	:= The socket library
+
+.TARGET	:= libsocket_p.a
+.TKIND	:= aout prof
+.TSRC	:= src/lib/socket/herror.c
+.TSRC   += $(wildcard src/lib/socket/386/*.s)
+.TDEP	:=
+.IMPS   := src/lib/socket/socket.imp
+.INSDIR	= lib/
+.TKEEP	:= 1
+include mkimplib.smak
+
+.TARGET	:= libsocket.a
+.TKIND	:= aout
+include mkimplib.smak
+
+
+# Forget temporary variables
+include comend.smak