Index: trunk/bootcode/airboot.md5
===================================================================
--- trunk/bootcode/airboot.md5	(revision 187)
+++ trunk/bootcode/airboot.md5	(revision 188)
@@ -1,1 +1,1 @@
-7611b247c861439e5e1819e403099ccf  airboot.bin
+7af8922d9ad553da88e32c98ee2717cd  airboot.bin
Index: trunk/bootcode/bldlevel.inc
===================================================================
--- trunk/bootcode/bldlevel.inc	(revision 187)
+++ trunk/bootcode/bldlevel.inc	(revision 188)
@@ -32,5 +32,5 @@
 
 ;
-; For some reason JWasm and Tasm don't accept 'EN' for instance, but need
+; For some reason JWasm and Tasm do not accept 'EN' for instance, but need
 ; it to be split-up. While 'iEN' does work. So all the strings that were not
 ; accepted are split-up.
Index: trunk/bootcode/fc.mnu
===================================================================
--- trunk/bootcode/fc.mnu	(revision 187)
+++ trunk/bootcode/fc.mnu	(revision 188)
@@ -3,28 +3,35 @@
 #
 
-B:	Build Development Version [EN]
+I:	Information
+	make dev-info
+-:	-------------------------------------
+B:	Build Anonymous Dev Version  [EN]
 	wmake -h dev DEV_BLD_LANG=en %BLDLVL_VENDOR= %BLDLVL_MACHINE= %CRC_IGNORE=y
-V:	Build Vendor Dev  Version [EN]
-	wmake -h dev DEV_BLD_LANG=en
-M:	Build Development Version [??]
+V:	Build Vendor    Dev Version  [EN]
+	wmake -h dev DEV_BLD_LANG=en %CRC_IGNORE=y
+F:	Build Fake  Release Version  [EN]
+	wmake dev DEV_BLD_LANG=en %RELEASE=y
+-:	-------------------------------------
+L:	Build Anonymous Dev Version  [LANG]
 {
 1:	English
-	wmake -h dev DEV_BLD_LANG=en
-2:	German
-	wmake -h dev DEV_BLD_LANG=de
-3:	Dutch
-	wmake -h dev DEV_BLD_LANG=nl
-4:	French
-	wmake -h dev DEV_BLD_LANG=fr
-5:	Italian
-	wmake -h dev DEV_BLD_LANG=it
-6:	Swedish
-	wmake -h dev DEV_BLD_LANG=sw
-7:	Russian
-	wmake -h dev DEV_BLD_LANG=ru
+	wmake -h dev DEV_BLD_LANG=en %BLDLVL_VENDOR= %BLDLVL_MACHINE= %CRC_IGNORE=y
+2:	German    (without FX)
+	wmake -h dev DEV_BLD_LANG=de %BLDLVL_VENDOR= %BLDLVL_MACHINE= %CRC_IGNORE=y
+3:	Dutch     (without FX)
+	wmake -h dev DEV_BLD_LANG=nl %BLDLVL_VENDOR= %BLDLVL_MACHINE= %CRC_IGNORE=y
+4:	French    (without FX)
+	wmake -h dev DEV_BLD_LANG=fr %BLDLVL_VENDOR= %BLDLVL_MACHINE= %CRC_IGNORE=y
+5:	Italian   (without FX)
+	wmake -h dev DEV_BLD_LANG=it %BLDLVL_VENDOR= %BLDLVL_MACHINE= %CRC_IGNORE=y
+6:	Swedish   (without FX)
+	wmake -h dev DEV_BLD_LANG=sw %BLDLVL_VENDOR= %BLDLVL_MACHINE= %CRC_IGNORE=y
+7:	Russian   (without FX)
+	wmake -h dev DEV_BLD_LANG=ru %BLDLVL_VENDOR= %BLDLVL_MACHINE= %CRC_IGNORE=y
 }
+-:	-------------------------------------
 C:	Clean
 	wmake -h clean
--:	--------------------------------
+-:	-------------------------------------
 I:	Install (/forcecode)
 	airboot2.exe /forcecode
Index: trunk/bootcode/fcl.mnu
===================================================================
--- trunk/bootcode/fcl.mnu	(revision 187)
+++ trunk/bootcode/fcl.mnu	(revision 188)
@@ -3,26 +3,32 @@
 #
 
-B:	Build Development Version [EN]
+I:	Information
+	make dev-info
+-:	-------------------------------------
+B:	Build Anonymous Dev Version  [EN]
 	make dev DEV_BLD_LANG=en BLDLVL_VENDOR= BLDLVL_MACHINE= USE_GNU_MAKE=y CRC_IGNORE=y
-V:	Build Vendor Dev  Version [EN]
+V:	Build Vendor    Dev Version  [EN]
 	make dev DEV_BLD_LANG=en BLDLVL_VENDOR=${USER} BLDLVL_MACHINE=${HOSTNAME} USE_GNU_MAKE=y
--:	------------------------------
-M:	Build Development Version [??]
+F:	Build Fake  Release Version  [EN]
+	make dev DEV_BLD_LANG=en RELEASE=y USE_GNU_MAKE=y
+-:	-------------------------------------
+L:	Build Anonymous Dev Version  [LANG]
 {
 1:	English
-	make dev DEV_BLD_LANG=en USE_GNU_MAKE=y CRC_IGNORE=y
-2:	German
-	make dev DEV_BLD_LANG=de USE_GNU_MAKE=y CRC_IGNORE=y
-3:	Dutch
-	make dev DEV_BLD_LANG=nl USE_GNU_MAKE=y CRC_IGNORE=y
-4:	French
-	make dev DEV_BLD_LANG=fr USE_GNU_MAKE=y CRC_IGNORE=y
-5:	Italian
-	make dev DEV_BLD_LANG=it USE_GNU_MAKE=y CRC_IGNORE=y
-6:	Swedish
-	make dev DEV_BLD_LANG=sw USE_GNU_MAKE=y CRC_IGNORE=y
-7:	Russian
-	make dev DEV_BLD_LANG=ru USE_GNU_MAKE=y CRC_IGNORE=y
+	make dev DEV_BLD_LANG=en BLDLVL_VENDOR= BLDLVL_MACHINE= USE_GNU_MAKE=y CRC_IGNORE=y
+2:	German    (without FX)
+	make dev DEV_BLD_LANG=de BLDLVL_VENDOR= BLDLVL_MACHINE= USE_GNU_MAKE=y CRC_IGNORE=y
+3:	Dutch     (without FX)
+	make dev DEV_BLD_LANG=nl BLDLVL_VENDOR= BLDLVL_MACHINE= USE_GNU_MAKE=y CRC_IGNORE=y
+4:	French    (without FX)
+	make dev DEV_BLD_LANG=fr BLDLVL_VENDOR= BLDLVL_MACHINE= USE_GNU_MAKE=y CRC_IGNORE=y
+5:	Italian   (without FX)
+	make dev DEV_BLD_LANG=it BLDLVL_VENDOR= BLDLVL_MACHINE= USE_GNU_MAKE=y CRC_IGNORE=y
+6:	Swedish   (without FX)
+	make dev DEV_BLD_LANG=sw BLDLVL_VENDOR= BLDLVL_MACHINE= USE_GNU_MAKE=y CRC_IGNORE=y
+7:	Russian   (without FX)
+	make dev DEV_BLD_LANG=ru BLDLVL_VENDOR= BLDLVL_MACHINE= USE_GNU_MAKE=y CRC_IGNORE=y
 }
+-:	-------------------------------------
 C:	Clean
 	make clean USE_GNU_MAKE=y
Index: trunk/bootcode/regular/std_text.asm
===================================================================
--- trunk/bootcode/regular/std_text.asm	(revision 187)
+++ trunk/bootcode/regular/std_text.asm	(revision 188)
@@ -27,27 +27,13 @@
 ; I'm going to sue your cheap ass, rape your dog and blow up your house. =)
 
-CopyrightVersionLen   equ   6
-;Copyright             db ' AiR-BOOT v1.06 - (c) 1998-2009 M. Kiewitz, Dedicated to Gerd Kiewitz', 0
-;Copyright             db ' AiR-BOOT v1.07 - (c) 2011 M. Kiewitz - Rousseau test-version >502G (build: #24)', 0
-;Copyright             db ' AiR-BOOT v1.07 - (c) 2011 M. Kiewitz   -  Release Candidate 1  -  (build: #25)', 0
-;Copyright             db ' AiR-BOOT v1.07 - (c) 1998-2011 M. Kiewitz, Dedicated to Gerd Kiewitz (rc2-b27)', 0
-;Copyright             db ' AiR-BOOT v1.07 - (c) 1998-2011 M. Kiewitz, Dedicated to Gerd Kiewitz (rc3-b31)', 0
-;Copyright             db ' AiR-BOOT v1.07 - (c) 1998-2011 M. Kiewitz, Dedicated to Gerd Kiewitz (rc4-b33)', 0
-;Copyright             db ' AiR-BOOT v1.07 - (c) 1998-2011 M. Kiewitz, Dedicated to Gerd Kiewitz (rc5-b35)', 0
-;Copyright             db ' AiR-BOOT v1.07 - (c) 1998-2011 M. Kiewitz, Dedicated to Gerd Kiewitz', 0
-;Copyright             db ' AiR-BOOT v1.0.8 - (c) 1998-2011 M. Kiewitz, Dedicated to Gerd Kiewitz', 0
-
-;Copyright             db ' AiR-BOOT v1.0.8-internal-beta - ** !! NOT FOR DISTRIBUTION !! **', 0
-;Copyright             db ' AiR-BOOT v1.0.8 - (c) 2012 M. Kiewitz    <<Release Candidate>>    (build: #18)', 0
-;Copyright             db ' AiR-BOOT v1.0.8 - (c) 2012 M. Kiewitz  <<Release Candidate 1>> (bld: 20120124)', 0
-;Copyright             db ' AiR-BOOT v1.0.8 - (c) 2012 M. Kiewitz  <<Release Candidate 2>> (bld: 20120224)', 0
-
-
-;~ Copyright             db ' AiR-BOOT v',BLDLVL_MAJOR_VERSION,'.',BLDLVL_MIDDLE_VERSION,'.',BLDLVL_MINOR_VERSION,' - (c) ',BLDLVL_YEAR,' M. Kiewitz  <<Internal Release 2l>> (bld: ',BLDLVL_YEAR,BLDLVL_MONTH,BLDLVL_DAY,')', 0
 
 ;
-; Masm found the above to be too complex, so we broke it up.
+; Copyright header on top of screen
 ;
 Copyright:
+IFDEF   RELEASE
+            ;
+            ; Copyright header as displayed on RELEASE version
+            ;
             db ' AiR-BOOT v'
             db BLDLVL_MAJOR_VERSION,'.'
@@ -55,18 +41,25 @@
             db BLDLVL_MINOR_VERSION,' - (c) 1998-'
             db BLDLVL_YEAR
-            ;~ db ' M. Kiewitz  <<Release Candidate 4>>  (bld: '
+            db ' Martin Kiewitz, Dedicated to Gerd Kiewitz'
+            db 0
+ELSE
+            ;
+            ; Copyright header as displayed on TESTBUILD version
+            ;
+            db ' AiR-BOOT v'
+            db BLDLVL_MAJOR_VERSION,'.'
+            db BLDLVL_MIDDLE_VERSION,'.'
+            db BLDLVL_MINOR_VERSION,' - (c) 1998-'
+            db BLDLVL_YEAR
             db ' M. Kiewitz   << Test Build >>   (bld:'
-            ;~ db ' Martin Kiewitz, Dedicated to Gerd Kiewitz'
             db BLDLVL_YEAR
             db BLDLVL_MONTH
             db BLDLVL_DAY,')'
             db 0
+ENDIF
 
-;
-; Normal copyright notice.
-;
-;~ Copyright   db ' AiR-BOOT v1.0.8 - (c) 1998-2012 M. Kiewitz, Dedicated to Gerd Kiewitz', 0
-
-
+; Length of version string to copy when displayed in menu and just before
+; booting the selected system.
+CopyrightVersionLen   equ   6
 
 ; License and source info.
@@ -105,8 +98,3 @@
 ; Build Information string.
 build_date      db  'Build Date: ',0
-jwasm_txt       db  'JWasm',0
-masm_txt        db  'Masm',0
-wasm_txt        db  'Wasm',0
-tasm_txt        db  'Tasm',0
 scanning_txt    db  'Scanning...',0
-unknown_txt     db  '????',0